help=[[

       Array view test program.
Usage:

  [pdelib2] aview2 inputfile

Input:
   inputfile must be one of .grid, .xgrid, .ele, .sg, .psg,  .lua

]]


processargs(arg)
inputfile=arg.files[1]

if arg.switches.h then print(help) return end
if not inputfile then return end

progSetErrorPublisherGUI()

glv2SetStateFile(filePrefFile("aview2.ini"))

viewer=glv2Create("GLViewer2",true)

grid=gRead(inputfile)

if not bool(grid) then
 print("Unable to read "..inputfile)
 return
end

if not istype(grid,"Grid") then
 print("No Grid "..inputfile)
 return
end

gPrintStatus(grid)

space=gsCreateFV(grid,gNode);
u = da1CreateS(space);
vset(0.0,u);
offset=-0.5

n=da1NAll(u)

coord=gCoord(grid)

for i=1,n do
 
 c=coord[i]
 
 dist=0
 for j=1,gSpaceDim(grid) do
   dist=dist+c[j]*c[j]
 end
 u[i]=math.sqrt(dist)+offset
end


a2View(viewer,u)

glv2Run()


