local hh_base=[[

         Grid and Geometry viewer for pdelib2.
Usage:
   [pdelib2] gview2 [inputfile [assignments|switches] ]

Input:
   inputfile must be one of .grid, .xgrid, .ele, .sg, .psg,  .lua

   If the input file type is .grid, .lua, or then any valid Lua script
   returning a grid or a geometry description is expected.  The viewer
   automatically    discriminates    between    grid    or    geometry
   description. If  a geometry description  is given, it uses  the the
   geometry description viewer (e.g.  tetview in 3D), unless the -grid
   flag has been invoked.

COMMAND LINE SWITCHES

   -h: Help.
   -q: Quiet.
   -grid: Force grid generation and grid view for geometry descriptions
]]

local hh
if bool(vsView) then
help=hh_base..[[

]]
else
help=hh_base..[[
   -voronoi Calculate and show Voronoi facets.

]]
end


processargs(arg)

if arg.switches.h then print(help) return end
if arg.switches.V then arg.switches.q=nil end

if arg.switches.voronoi and not bool(vsView) then return end

progSetErrorPublisherGUI()

glv2SetStateFile(filePrefFile("gview2.ini"))


viewer=glv2Create(10,10,"glViewer2",true)

inputfile=arg.files[1]


if not inputfile then

 g2View(viewer)

else
 
 basename,ext=splitfilename(inputfile)
 
 if not arg.switches.grid and (ext=="grid" or ext=="lua") then
   xgrid=dofile(inputfile)
 else
   xgrid=gRead(inputfile)
 end
 
 if not xgrid then error("Unable to read "..inputfile) end
 
 if not bool(xgrid) then
  
  g2View(viewer)
  
 else
 
  if istype(xgrid,"Grid") then
   gPrintStatus(xgrid)
   hmax=gHMax(xgrid)
   print("region  hmax")
   for i=1,da1NRow(hmax) do
      print(i, hmax[i])
   end
   if arg.switches.voronoi then
      print("voronoi")
      vgrid=vsCreateCellwise(xgrid)
      vsView(viewer,vgrid)
   else
      g2View(viewer,xgrid,inputfile)
   end
  else
   xgrid=GridGenIO(xgrid)
   g2View(viewer,xgrid,inputfile)
  end
  
 end
 
end

glv2Run()



